<template>
  <main>
    <div class="main">
      <div class="container">
        <token-section v-for="(category, categoryIndex) in categories" :key="categoryIndex" :token-title="category">
          <template v-for="(type, typeIndex) in getTypesByCatetory(category)" :key="typeIndex">
            <token-item
              v-if="tokensObject[category][type].isSource"
              :token-name="tokensObject[category][type].path.join('.')"
              :token-value="tokensObject[category][type].value"
            >
              <token-example
                :currentContext="category"
                :token-css="getCssName(tokensObject[category][type].name)"
              ></token-example>
            </token-item>
            <token-section v-else :token-subtitle="type" is-subcontent>
              <token-item
                v-for="(token, tokenIndex) in getTokens(tokensObject[category][type])"
                :key="tokenIndex"
                :token-name="token.path.join('.')"
                :token-value="token.value"
              >
                <token-example :currentContext="category" :token-css="getCssName(token.name)"></token-example>
              </token-item>
            </token-section>
          </template>
        </token-section>
      </div>
    </div>
  </main>
</template>

<script>
import tokens from "../../node_modules/@govbr-ds/tokens/dist/js/tokens.json"

import TokenExample from "./tokenExample.vue"
import tokenItem from "./tokenItem.vue"
import tokenSection from "./tokenSection.vue"

const Dashboard = {
  name: "dashboard",
  components: {
    TokenExample,
    tokenItem,
    tokenSection,
  },
  data() {
    return {
      tokensObject: tokens,
    }
  },
  computed: {
    categories() {
      return Object.keys(this.tokensObject)
    },
  },
  methods: {
    getCssName(camelCaseName) {
      var kebabCaseStr = camelCaseName.replace(/([a-z])([A-Z])/g, "$1-$2").toLowerCase()
      var cssVariable = "--" + kebabCaseStr.replace(/(\d+)/g, "-$1")

      return cssVariable
    },

    getTokens(object) {
      const tokens = []

      function traverse(currentObj) {
        if (!currentObj.isSource) {
          for (const key in currentObj) {
            traverse(currentObj[key])
          }
        } else {
          tokens.push(currentObj)
        }
      }

      traverse(object)

      return tokens
    },

    getTypesByCatetory(category) {
      return Object.keys(this.tokensObject[category])
    },
  },
}

export default Dashboard
</script>

<style></style>
